package main

import (
	"time"

	"github.com/rudi9719/loggy"
)

// Config struct used for bot
type Config struct {
	GuildID       string
	AdminChannel  string
	AdminRole     string
	MonitorRole   string
	IntroChann    string
	MonitorChann  string
	VerifiedRole  string
	BumpTime      time.Time
	LastBumper    string
	Stats         map[string]int
	Unverified    map[string]time.Time
	Verifications map[string]Verification
	Probations    map[string]time.Time
	LogOpts       loggy.LogOpts
}

// Verification struct used for storing and logging
type Verification struct {
	UserID    string
	Username  string
	Photo     string
	Submitted time.Time
	Status    string
	Admin     string
	Closed    time.Time
}

type linkedAccount struct {
	domainUser  string
	discordUser string
	sigHash     string
}

// Tokens are the Login Token struct
type Tokens struct {
	Username  string
	IP        string
	Password  string
	Timestamp time.Time
}
